﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;

namespace SquaresWPF
{
    class SquaresViewModel : DependencyObject
    {
        public string Input
        {
            get { return (string)GetValue(InputProperty); }
            set { SetValue(InputProperty, value); }
        }

        public static readonly DependencyProperty InputProperty =
            DependencyProperty.Register("Input", typeof(string), typeof(SquaresViewModel), new UIPropertyMetadata(""));

        public IEnumerable<Tuple<int, int>> Squares
        {
            get { return (IEnumerable<Tuple<int, int>>)GetValue(SquaresProperty); }
            set { SetValue(SquaresProperty, value); }
        }

        public static readonly DependencyProperty SquaresProperty =
            DependencyProperty.Register("Squares", typeof(IEnumerable<Tuple<int, int>>), typeof(SquaresViewModel), new UIPropertyMetadata(null));

        ActionCommand processCommand;
        public ActionCommand ProcessCommand
        {
            get 
            {
                if (processCommand == null)
                {
                    processCommand = new ActionCommand(() => Process());
                }

                return processCommand;
            }
        }
        
        void Process()
        {
            if (Input.Length == 0)
            {
                MessageBox.Show("Enter something!", "Notification", MessageBoxButton.OK, MessageBoxImage.Information);
            }

            try
            {
                Squares = Input.Split(new char[] { ',' }, StringSplitOptions.RemoveEmptyEntries).Select(s => int.Parse(s)).Select(i => Tuple.Create(i, i * i)).ToArray();
            }
            catch
            {
                MessageBox.Show("Error parsing numbers!", "Error", MessageBoxButton.OK, MessageBoxImage.Error);
            }
        }
    }
}
