﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace SquaresWinForms
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        bool ReadAndValidate(string input, out int[] numbers, out string error)
        {
            error = null;
            numbers = null;           

            string[] split = input.Split(new char[] {','}, StringSplitOptions.RemoveEmptyEntries);

            if (split.Length == 0)
            {
                error = "Enter something!";
                return false;
            }

            numbers = new int[split.Length];

            try
            {
                for (int i = 0; i < split.Length; i++)
                {
                    numbers[i] = int.Parse(split[i]);
                }
            }
            catch
            {
                error = "Error parsing numbers!";
                return false;
            }

            return true;
        }

        private void processButton_Click(object sender, EventArgs e)
        {
            string error;
            int[] numbers;

            if (ReadAndValidate(inputBox.Text, out numbers, out error))
            {
                squaresList.Items.Clear();

                foreach (var n in numbers)
                {
                    squaresList.Items.Add(n * n);
                }
            }
            else
            {
                MessageBox.Show(error, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error);
            }
        }
    }
}
